#include "incs.h"
#include "class_data.h"
#include "utils.h"

Class_Data::Class_Data (FILE* class_data_file, int num_points, 
			int num_inputs, int num_targets ):
  class_data_fp(class_data_file),
  n_points(num_points),
  n_inputs(num_inputs+1),
  n_targets(num_targets)
{
  input_matrix = RealMatrix2(n_points, n_inputs);
  target_matrix = RealMatrix2(n_points, n_targets);
  int n_targ = n_targets;
  if(n_targets == 2) n_targ = 1;
  float tmp;
  for(int point = 0; point < n_points; point ++){
    input_matrix[point][0] = 1.0;
    for(int ipdim = 1; ipdim < n_inputs; ipdim ++){
      if(feof(class_data_fp))
	error(1, "End of class_data file !\n");
      fscanf(class_data_fp,"%f",&tmp);
      input_matrix[point][ipdim] = (real) tmp;
    }
    for(int opdim = 0; opdim < n_targ; opdim ++){
      if(feof(class_data_fp))
		error(1, "End of class_data file !\n");
      fscanf(class_data_fp,"%f",&tmp);
	  if(n_targ == 1) {
		if(tmp == -1) {
		  target_matrix[point][0] = 0;
		  target_matrix[point][1] = 1;
		}
		else {
		  if(tmp == 1) {
			target_matrix[point][0] = 1;
			target_matrix[point][1] = 0;
		  }
		  else{
			error(1, "screw up in class_data");
		  }
		}
	  }
	  else
		target_matrix[point][opdim] = (real) tmp;
	}
  }
}

Class_Data::~Class_Data()
{
  
}

real Class_Data::get_next_input ( int pointer, real* input )
{
  return input[pointer];
}

real Class_Data::get_next_target ( int pointer, real* target )
{
  return target[pointer];
}

void Class_Data::print ( )
{
  for(int point = 0; point < n_points; point ++){
    printf("inputs = ");
    for(int ipdim = 0; ipdim < n_inputs; ipdim ++){
      printf("%f ", input_matrix[point][ipdim]);
    }
    printf("\n");
    printf("targets = ");
    for(int opdim = 0; opdim < n_targets; opdim ++){
      printf("%f ", target_matrix[point][opdim]);
    }
    printf("\n");
  }
}


  
  
real** Class_Data::get_inputs(int offset)
{
  return input_matrix + (offset*n_inputs);
}

real** Class_Data::get_targets(int offset)
{
  return target_matrix + (offset*n_targets);
}

  
