/*----------------
(c) Lexicus, a division of Motorola
Author : Steve Waterhouse
File   : functions.h
Date   : Thu 13 Jul 1995
---------------*/
#ifndef		FUNCS_H
#define		FUNCS_H

#ifdef	__cplusplus
extern	"C" {
#endif

#include "consts.h"

long get_seed();
void set_seed(long seed);
long get_random();
double get_drand();
void    check_arg(real, char *);

real    Spow(real,real);
real    gaussian_full(real *,real *,real **,real, int);
real    gaussian_diag(real *,real *,real *,real, int);
real    gaussian_var(real *,real *,real, int);
void    softmax(real *, real *, int);
real    sigmoid(real );
void    softmax_output(real **,real *,real *,int,int);
void    linear_output(real **,real *,real *, int, int);

void    limit_outputs(real *, int, real, real);
real    ierf(real ) ;
real    LAdd(real x, real y);
real    Slog(real arg);
void     log_softmax(real *output, real *arg, int n_output);
real    LSub(real x, real y);
real*  randomize_vector(real* in_vec, int dim, int* map);
real** randomize_matrix_rows(real** in_vec, int dim, int dim2, int* map);
void randomize_matrix_rows2(real** in_vec, int dim, int dim2, int* map, real** out_vec);
void remap_matrix_rows2(real** in_vec, int dim, int dim2, int* map, real** out_vec);
real** remap_matrix_rows(real** in_vec, int dim, int dim2, int* map);

inline real  Sexp(real arg) 
{
  return (arg < LSMALL) ? 0.0 : exp(arg);
}

real ran0(int* idum);
real ran1(int* idum);
real ran2(int* idum);
real gasdev(int* idum);
void qcksrt(int n, double* arr);
void indexx(int n, double* arrin, int* indx);
float gammln(float xx);

#ifdef	__cplusplus
}
#endif
#endif

