#ifndef NODE_NT_H
#define NODE_NT_H

#include "node.h"
#include "node_term.h"
#include "network.h"

class Node_NT : public Node
{
public:
  Node_NT(int n_batch, 
	  int num_child, 
	  int num_ip, 
	  int num_op,
	  Network* gt, 
	  Node** xprts,
	  int debug,
	  int node_id);
  Node_NT(int n_batch, FILE* fp);
  Node_NT(const Node_NT & old);
  Node_NT(Node& old, int num_child);
  virtual ~Node_NT();
  Node* get_child(int xp){return child[xp];};
  void set_child(int xp, Node* ch){ child[xp] = ch; };
  void replace_child(int node_id, Node* ch);
  Network* get_gate(){ return gate;};
  void set_gate(Network* gt){ gate = gt;}
  void randomize_weights(real offset);
  void randomize_weights(real xprt_offset, real gate_offset);
  void update_params(int n_points, real** in, real** targ);
  void update_hypers(int n_points, real** in,real** targ);
  void train(int n_points, real** in, real** targ);
  void update_params(int n_points, real** in, real** targ,
					 int node_id);
  void update_hypers(int n_points, real** in,real** targ,
					 int node_id);
  void train(int n_points, real** in,real** targ, 
			 int node_id);  
  void train_gates(int n_points, real** in);
  void init(int n_points, real** in, real** targ);
  int is_terminal() { return 0;};
  void print_posteriors(int point);
  void read_weights(FILE* fp);
  void write_weights(FILE* fp);
  double get_joint(int point,  real* targ);
  double get_aux(int point,  real* targ);
  void print_likes();
  double get_error(int point, real* targ);
  int get_num_children(){ return n_child;};
  void find_posts2(int point);
  void find_posts1(int point);
  void set_posts(int point);
real set_dens(int point, real* in, real* targ);
  real get_dens();
  void set_joint_prob(real prob, real* in, int point);
  real get_joint_prob(int point) { return joint_prob[point];};
  void reset_nodes();
  void get_new_gate_targets(int n_points);
  real** get_gate_targets() { return gate_targets;};
private:
  int n_child;
  Network* gate;
  Node** child;
  real** gate_targets;

  real* gate_op;
};

#endif
